/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.104 by jmc, Tue Oct 2 14:24:42 2007 UTC revision 1.122 by jmc, Wed Apr 15 22:22:36 2009 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mth)                   run multi threaded (using eedata.mth)"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18        echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "  (-of=|-optfile=)STRING   list of optfiles to use"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22        echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23        echo "                             (DEF=\"../tools/mpack-1.6\")"
24      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
26      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
# Line 27  usage() Line 30  usage()
30      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
31      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
32      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34      echo "  (-command) STRING        command to run"      echo "  (-command) STRING        command to run"
35      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
36      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
# Line 64  usage() Line 68  usage()
68  build_mpack()  build_mpack()
69  {  {
70      printf "building the mpack utility...  "      printf "building the mpack utility...  "
71      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
72        if test ! -x $MPACK ; then
73          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
74              echo              echo
75              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
# Line 73  build_mpack() Line 78  build_mpack()
78              echo              echo
79              HAVE_MPACK=f              HAVE_MPACK=f
80          fi          fi
         printf "building mpack...  "  
81          if test "x$CC" = x ; then          if test "x$CC" = x ; then
82              export CC=cc              export CC=cc
83          fi          fi
84            printf "building mpack (using CC=$CC)...  "
85          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
86          RETVAL=$?          RETVAL=$?
87          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 87  build_mpack() Line 92  build_mpack()
92          else          else
93              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
94              HAVE_MPACK=t              HAVE_MPACK=t
95                echo "done"
96          fi          fi
97      else      else
98          HAVE_MPACK=t          HAVE_MPACK=t
99            echo "already exist"
100      fi      fi
     echo "OK"  
101  }  }
102    
103  testoutput_var()  testoutput_var()
# Line 174  testoutput_var() Line 180  testoutput_var()
180      return $digits_of_similarity      return $digits_of_similarity
181  }  }
182    
 dashnum()  
 {  
     # dashnum n1 n2 n3 ...  
     #  
     #  print numbers using %3i format or "--" if number = 99  
   
     for num in $@ ; do  
         if [ $num = 99 ]; then  
             printf ' --'  
         else  
             printf '%3i' $num  
         fi  
     done  
 }  
   
 check_for_add_mon_output()  
 {  
     # Check for additional types of monitor output  
     if test "x$1" = x ; then  
         return  
     fi  
   
     for ii in $PTRACERS_NUM ; do  
         eval "HAVE_PTR0"$ii"=f"  
     done  
   
     ptr_add="trcstat_ptracerXX_min trcstat_ptracerXX_max"  
     ptr_add="$ptr_add trcstat_ptracerXX_mean trcstat_ptracerXX_sd"  
     for ii in $PTRACERS_NUM ; do  
         for jj in $ptr_add ; do  
             name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`  
             tst=`grep $name $1 | wc -l | awk '{print $1}'`  
             if test ! "x$tst" = x0 ; then  
                 eval "HAVE_PTR0"$ii"=t"  
             fi  
         done  
         #  eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"'  
     done  
 }  
   
183  testoutput_run()  testoutput_run()
184  {  {
185      # testoutput_run directory subdir reference_output      # testoutput_run directory subdir reference_output
# Line 231  testoutput_run() Line 197  testoutput_run()
197          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
198                                 | sed 's/+//g' | sed "s/^$sVar//"`                                 | sed 's/+//g' | sed "s/^$sVar//"`
199          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
200          for ii in 1 2 3 4 5 6 7 8 9 ; do          # check for ptracer output in reference_output file :
201            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`          outpref=$1/results/$3
202           #echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
203            if test "x$tst" != xt ; then listVar=`echo "$listVar" | sed "s/ pt$ii..//g"` ; fi          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
204          done          for ii in $PTRACERS_NUM ; do
205          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){t+=($i==$1)}; print t }'`              ptrfound=0
206                for jj in $ptr_mon ; do
207                    name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
208                    tst=`grep $name $outpref | wc -l | awk '{print $1}'`
209                    if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
210                done
211                if test $ptrfound = '1' ; then
212                    eval "HAVE_PTR0"$ii"=t"
213                else
214                    eval "HAVE_PTR0"$ii"=f"
215                  if test "x$ADM" = x -a "x$OADM" = x; then
216                  # remove this ptr from the list of output variable to check
217                  # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
218                    listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
219                  fi
220                fi
221            #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
222            done
223            tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
224          if test $tst != 1 ; then          if test $tst != 1 ; then
225            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
226                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
# Line 331  genmakemodel() Line 315  genmakemodel()
315          (          (
316              cd $1;              cd $1;
317              command="$GENMAKE2  -ds -m $MAKE"              command="$GENMAKE2  -ds -m $MAKE"
318              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
                 command="$command --mods=../code"  
             else  
319                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
320                elif test "x$OADM" = xt ; then
321                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
322                else
323                    command="$command --mods=../code"
324              fi              fi
325              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
326                  command="$command --optfile=$OPTFILE"                  command="$command --optfile=$OPTFILE"
# Line 342  genmakemodel() Line 328  genmakemodel()
328              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
329                  command="$command -ieee"                  command="$command -ieee"
330              fi              fi
331                if test "x$GSL" = xt ; then
332                    command="$command -gsl"
333                fi
334              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
335                  command="$command -mpi"                  command="$command -mpi"
336              fi              fi
337                if test "x$MULTI_THREAD" = xt ; then
338                #- run multi-threaded using OpenMP:
339                    command="$command -omp"
340                fi
341              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
342                  command="$command -ts"                  command="$command -ts"
343              fi              fi
# Line 356  genmakemodel() Line 349  genmakemodel()
349              fi              fi
350              fi              fi
351              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
352              $command > make.log 2>&1              # $command > make.log 2>&1
353                eval $command > make.log 2>&1
354              RETVAL=$?              RETVAL=$?
355              #  Reduce the size of the testing emails!              #  Reduce the size of the testing emails!
356              head -100 Makefile > $CDIR/Makefile_head              head -100 Makefile > $CDIR/Makefile_head
# Line 414  run_clean() Line 408  run_clean()
408              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
409              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
410              rm -rf mnc_test_*              rm -rf mnc_test_*
411                rm -f *_MIT_CE_000.opt0000 costfunction*0000
412              echo successful 1>&2              echo successful 1>&2
413              exit 0              exit 0
414          )          )
# Line 450  makemodel() Line 445  makemodel()
445          cd $1;          cd $1;
446          if test -r Makefile ; then          if test -r Makefile ; then
447              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
448              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
449                    $MAKE adall >> make.log 2>&1
450                elif test "x$OADM" = xt ; then
451                    $MAKE adAll >> make.log 2>&1
452                else
453                  if test "x$JOBS" = x ; then                  if test "x$JOBS" = x ; then
454                      $MAKE >> make.log 2>&1                      $MAKE >> make.log 2>&1
455                  else                  else
456                      $MAKE -j $JOBS >> make.log 2>&1                      $MAKE -j $JOBS >> make.log 2>&1
457                  fi                  fi
             else  
                 $MAKE adall >> make.log 2>&1  
458              fi              fi
459              RETVAL=$?              RETVAL=$?
460              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
# Line 484  symlink_mpifiles() Line 481  symlink_mpifiles()
481      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
482            
483      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
484      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
485    
486      #  Is this an MPI run?      #  Is this an MPI run?
487      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 542  linkdata() Line 539  linkdata()
539                      if test -h eedata ; then rm -f eedata ; fi                      if test -h eedata ; then rm -f eedata ; fi
540                  fi                  fi
541              fi              fi
542                prevDir='NONE'
543              for ldir in $* ; do              for ldir in $* ; do
544                  if test -d "../"$ldir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
545                      printf 'ldir='${ldir} 1>&2                      printf 'ldir='${ldir} 1>&2
546                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
547                      for i in $files ; do                      for i in $files ; do
# Line 559  linkdata() Line 557  linkdata()
557                      fi                      fi
558                      printf ' ; ' 1>&2                      printf ' ; ' 1>&2
559                  fi                  fi
560                    prevDir=$ldir
561              done              done
562          )          )
563      fi      fi
# Line 575  runmodel() Line 574  runmodel()
574          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ...' $1 1>&2
575          # make output.txt          # make output.txt
576          echo          echo
577            if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
578                diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
579                outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
580            fi
581          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
582              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
583              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
584          fi          fi
585          if test ! -x $EXECUTABLE ; then          if test ! -x $EXECUTABLE ; then
586                  rm -f run.log ; touch run.log                  rm -f $RUNLOG ; touch $RUNLOG
587                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
588                  echo " no executable:" $EXECUTABLE >> run.log                  echo " no executable:" $EXECUTABLE >> $RUNLOG
589                  RETVAL=8                  RETVAL=8
590                  ENDVAL=-1                  ENDVAL=-1
591          else          else
592              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
593                # output do not exist or is older than executable:                # output do not exist or is older than executable:
594                  rm -f run.log ; touch run.log                  rm -f $RUNLOG ; touch $RUNLOG
595                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
596                  ( eval $COMMAND ) >> run.log 2>&1                  ( eval $COMMAND ) >> $RUNLOG 2>&1
597                  RETVAL=$?                  RETVAL=$?
598              else              else
599                  RETVAL=0                  RETVAL=0
600                  if test -f run.log ; then                  if test -f $RUNLOG ; then
601                      if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
602                      echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
603                  else                  else
604                      touch run.log                      touch $RUNLOG
605                      if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
606                      echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
607                      echo " no previous run.log: assume NORMAL END" >> run.log 2>&1                      echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
608                  fi                  fi
609              fi              fi
610              ENDVAL=`cat run.log | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`              ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
611          fi          fi
612          rm -f run.log_00          rm -f run.log_tmp
613          #if test "x$RETVAL" = x0 ; then          #if test "x$RETVAL" = x0 ; then
614          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
615              tail run.log              tail $RUNLOG
616              echo successful 1>&2              echo successful 1>&2
617              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
618              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
619              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
620              return 0              return 0
621          else          else
622              tail run.log              tail $RUNLOG
623              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
624              cp run.log $CDIR"/run.log"              cp $RUNLOG $CDIR"/"$RUNLOG
625              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
626              return 1              return 1
627          fi          fi
# Line 629  createcodelet() Line 632  createcodelet()
632  {  {
633      # create codelet for comparing model output      # create codelet for comparing model output
634    
635      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
636      cat > tr_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
637  #include <stdio.h>  #include <stdio.h>
638  #include <math.h>  #include <math.h>
# Line 726  scandirs() Line 729  scandirs()
729  debug=0  debug=0
730  verbose=1  verbose=1
731  clean=0  clean=0
 expts=''  
 # ieee=1  
732    
733  IEEE=true  IEEE=true
734  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
735      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
736  fi  fi
737    GSL=f
738    
739  CLEANUP=f  CLEANUP=f
740  QUICK=f  QUICK=f
# Line 749  TESTDIRS= Line 750  TESTDIRS=
750  SKIPDIRS=  SKIPDIRS=
751  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
752  HAVE_MPACK=  HAVE_MPACK=
753  MPACK="$MPACKDIR/mpack"  MPACK=
754  COMMAND=  COMMAND=
755  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
756      MAKE=make      MAKE=make
# Line 764  OUTDIR= Line 765  OUTDIR=
765  DELDIR=  DELDIR=
766    
767  ADM=  ADM=
768    OADM=
769    
770  # Additional monitor types  # list of pTracers to check for monitor output
771  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
772    
773  MATCH_CRIT=13  MATCH_CRIT=13
# Line 798  for ac_option ; do Line 800  for ac_option ; do
800              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
801          -addr=* | --addr=*)          -addr=* | --addr=*)
802              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
803            -mpackdir | --mpackdir | -mpd | --mpd)
804                ac_prev=MPACKDIR ;;
805            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
806                MPACKDIR=$ac_optarg ;;
807    
808          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
809              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
# Line 861  for ac_option ; do Line 867  for ac_option ; do
867    
868          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
869    
870            -oad) OADM=t; NODEPEND=t ;;
871    
872          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
873          -noieee) IEEE= ;;          -noieee) IEEE= ;;
874            -gsl) GSL=t ;;
875    
876          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
877          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 899  fi Line 908  fi
908  #- setting for forward or ADM testing  #- setting for forward or ADM testing
909  if test "x$ADM" = xt ; then  if test "x$ADM" = xt ; then
910      code_dir=code_ad      code_dir=code_ad
911      input_dirs='input_ad input'      inputdir=input_ad
912      ref_outp="output_adm.txt"      ref_outp="output_adm.txt"
913      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
914    elif test "x$OADM" = xt ; then
915        code_dir=code_oad
916        inputdir=input_oad
917        ref_outp="output_oadm.txt"
918        EXECUTABLE="mitgcmuv_ad"
919  else  else
920      code_dir=code      code_dir=code
921      input_dirs='input'      inputdir=input
922      ref_outp="output.txt"      ref_outp="output.txt"
923      EXECUTABLE="mitgcmuv"      EXECUTABLE="mitgcmuv"
924  fi  fi
# Line 954  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 968  if test "x$OPTFILE" = xNONE -a "x$MITGCM
968      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
969  fi  fi
970    
971    RUNLOG="run.log"
972  OUTPUTFILE=$ref_outp  OUTPUTFILE=$ref_outp
973  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
974      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
# Line 968  echo "OK (COMMAND= $COMMAND )" Line 983  echo "OK (COMMAND= $COMMAND )"
983  #  (use default or load experiment-specific list from file "tr_checklist")  #  (use default or load experiment-specific list from file "tr_checklist")
984  # content : 1rst = main variable used to decide if it pass or FAIL  # content : 1rst = main variable used to decide if it pass or FAIL
985  #         others = number of matching digits to be printed in summary.txt  #         others = number of matching digits to be printed in summary.txt
986  if test "x$ADM" = x ; then  if test "x$ADM" = x -a "x$OADM" = x; then
987      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
988      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
989      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
# Line 983  fi Line 998  fi
998  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
999  createcodelet  createcodelet
1000    
1001  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1002  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
1003      echo "skipping mpack build"      echo "skipping mpack build"
1004  else  else
1005      build_mpack      build_mpack
1006  fi  fi
1007    
1008  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1009    CMDLINE=$0
1010    for xx in "$@" ; do nw=`echo $xx | wc -w`
1011        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1012                            else CMDLINE="$CMDLINE '$xx'" ; fi
1013    done
1014    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1015  MACH=`hostname`  MACH=`hostname`
1016  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1017  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1018  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1019  if test "x$OUTDIR" != x ; then  if test "x$OUTDIR" != x ; then
1020      BASE="tr_"$OUTDIR"_"$DATE"_"      BASE="tr_"$OUTDIR"_"$DATE"_"
1021    else
1022        short_name=`hostname | sed 's/\..*$//'`
1023        BASE="tr_"$short_name"_"$DATE"_"
1024  fi  fi
1025  DNUM=0  DNUM=0
1026  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
# Line 1011  if test "x$RETVAL" != x0 ; then Line 1035  if test "x$RETVAL" != x0 ; then
1035      exit 1      exit 1
1036  fi  fi
1037  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1038  start_date=`date`  start_date=`date`
1039  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1040    echo 'run:' $CMDLINE >> $SUMMARY
1041    echo 'on :' $UNAMEA  >> $SUMMARY
1042    
1043  of_path=  of_path=
1044  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 1042  else Line 1067  else
1067  fi  fi
1068  echo  echo
1069  echo >> $SUMMARY  echo >> $SUMMARY
1070  if test "x$ADM" = x ; then  if test "x$ADM" = x -a "x$OADM" = x; then
1071      if [ $MATCH_CRIT -lt 10 ] ;      if [ $MATCH_CRIT -lt 10 ] ;
1072      then line_0="default  "$MATCH_CRIT ;      then line_0="default  "$MATCH_CRIT ;
1073      else line_0="default "$MATCH_CRIT ; fi      else line_0="default "$MATCH_CRIT ; fi
# Line 1053  if test "x$ADM" = x ; then Line 1078  if test "x$ADM" = x ; then
1078      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1079      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1080      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
         #  tst=`eval 'echo $HAVE_PTR0'$ii`  
         #  if test "x$tst" = xt ; then  
1081          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
1082          line_1="$line_1        m  s"          line_1="$line_1        m  s"
1083          line_2="$line_2  m  m  e  ."          line_2="$line_2  m  m  e  ."
1084          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1085          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
         #  fi  
1086      done      done
1087      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1088      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
# Line 1087  fi Line 1109  fi
1109  #  ...and each test directory...  #  ...and each test directory...
1110  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1111            
1112        # set builddir & rundir:
1113        builddir="build"
1114        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1115        rundir="run"
1116        if test ! -d $dir/$rundir ; then
1117            rundir=$builddir
1118        fi
1119        CODE_DIR=$dir/$code_dir
1120        BUILD_DIR=$dir/$builddir
1121    
1122      #  Cleanup only!      #  Cleanup only!
1123      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1124          if test -r $dir/build/Makefile ; then          if test -r $BUILD_DIR/Makefile ; then
1125              echo '  ------  clean dir:' $dir/build              echo '  ------  clean dir:' $dir/$builddir
1126              ( cd $dir/build ; make CLEAN )              ( cd $BUILD_DIR ; make CLEAN )
1127          fi          fi
1128          if test -d $dir/run/CVS ; then          if test -d $dir/$rundir/CVS ; then
1129              echo '  ------  clean dir:' $dir/run              echo '  ------  clean dir:' $dir/$rundir
1130              run_clean $dir/run              run_clean $dir/$rundir
1131          fi          fi
1132          (          (
1133              cd $dir              cd $dir
# Line 1111  for dir in $TESTDIRS ; do Line 1143  for dir in $TESTDIRS ; do
1143          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1144          continue          continue
1145      fi      fi
     if test "x$ADM" = x ; then  
         check_for_add_mon_output  $fout  
     fi  
1146    
1147      # Check for additional types of monitor output      # Check for specific files for particular type of run
   
     builddir="build"  
     if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi  
     rundir="run"  
     if test ! -d $dir/$rundir ; then  
         rundir=$builddir  
     fi  
     CODE_DIR=$dir/$code_dir  
     BUILD_DIR=$dir/$builddir  
1148    
1149      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1150          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
# Line 1137  for dir in $TESTDIRS ; do Line 1157  for dir in $TESTDIRS ; do
1157    
1158      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1159      extra_runs=      extra_runs=
1160      if test "x$ADM" = x ; then      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1161          ex_run_dirs=`( cd $dir ; echo input.* )`      #echo "ex_run_dirs='$ex_run_dirs'"
1162          #echo "ex_run_dirs='$ex_run_dirs'"      for exd in $ex_run_dirs ; do
1163          for exd in $ex_run_dirs ; do          name=`echo $exd | sed -e "s/$inputdir\.//"`
1164              name=`echo $exd | sed -e 's/input.//g'`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1165              outf="$dir/results/output.$name.txt"          outf="$dir/results/$refExOut"
1166              if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1167                  if test "x$MULTI_THREAD" = "xt" ; then              if test "x$MULTI_THREAD" = "xt" ; then
1168                      if test -r $dir"/"$exd"/eedata.mth" ; then                  if test -r $dir"/"$exd"/eedata.mth" ; then
                         extra_runs="$extra_runs $name"  
                     #else echo $dir"/"$exd"/eedata.mth: not found"  
                     fi  
                 else  
1169                      extra_runs="$extra_runs $name"                      extra_runs="$extra_runs $name"
1170                    #else echo $dir"/"$exd"/eedata.mth: not found"
1171                  fi                  fi
1172                else
1173                    extra_runs="$extra_runs $name"
1174              fi              fi
1175          done          fi
1176      fi      done
1177    
1178      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1179      echo      echo
# Line 1183  for dir in $TESTDIRS ; do Line 1202  for dir in $TESTDIRS ; do
1202              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1203              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1204              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1205              && linkdata $dir/$rundir $input_dirs \              && linkdata $dir/$rundir $inputdir input \
1206              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1207              && results=`testoutput_run $dir $rundir $ref_outp`              && results=`testoutput_run $dir $rundir $ref_outp`
1208      fi      fi
1209            
1210      echo      echo
 # --> same processing for adjoint & forward test  
1211          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1212          echo          echo
1213          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
# Line 1199  for dir in $TESTDIRS ; do Line 1217  for dir in $TESTDIRS ; do
1217          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1218          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1219          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1220            if test "x$ADM" = xt ; then
1221                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1222                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1223                                    >> $CDIR"/summary.txt"
1224            fi
1225    
1226          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1227              unset run              unset run
1228              results=$EMPTY_RESULTS              results=$EMPTY_RESULTS
1229                #  reference output file
1230                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1231              #  Create an output dir for each OPTFILE/tdir.ex combination              #  Create an output dir for each OPTFILE/tdir.ex combination
1232              rel_CDIR=$DRESULTS"/"$dir"."$ex              rel_CDIR=$DRESULTS"/"$dir"."$ex
1233              mkdir $rel_CDIR              mkdir $rel_CDIR
1234              CDIR=`pwd`"/$rel_CDIR"              CDIR=`pwd`"/$rel_CDIR"
1235              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1236              run_clean $dir/tr_run.$ex              run_clean $dir/tr_run.$ex
1237              linkdata $dir/tr_run.$ex input.$ex input              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1238              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1239                  && results=`testoutput_run $dir tr_run.$ex "output.${ex}.txt"`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
1240              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1241              fres="$fres.$ex"              fres="$fres.$ex"
1242              echo              echo
# Line 1222  for dir in $TESTDIRS ; do Line 1247  for dir in $TESTDIRS ; do
1247              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1248              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1249              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1250                if test "x$ADM" = xt ; then
1251                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1252                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1253                                       >> $CDIR"/summary.txt"
1254                fi
1255              if test "x$POSTCLEAN" = xt ; then              if test "x$POSTCLEAN" = xt ; then
1256                  run_clean $dir/tr_run.$ex                  run_clean $dir/tr_run.$ex
1257              fi              fi
1258          done          done
 # <-- same processing for adjoint & forward test  
     if test "x$ADM" = xt ; then  
         grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \  
                            >> $CDIR"/summary.txt"  
     fi  
1259    
1260      #postclean $dir/$builddir      #postclean $dir/$builddir
1261      if test "x$POSTCLEAN" = xt ; then      if test "x$POSTCLEAN" = xt ; then
# Line 1243  for dir in $TESTDIRS ; do Line 1268  for dir in $TESTDIRS ; do
1268  done  done
1269    
1270  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
1271  echo $start_date >> $SUMMARY  echo "$start_date" >> $SUMMARY
1272  printf "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
1273  date >> $SUMMARY  date >> $SUMMARY
1274    

Legend:
Removed from v.1.104  
changed lines
  Added in v.1.122

  ViewVC Help
Powered by ViewVC 1.1.22